	IDEAL
	%TITLE "STRKIT.ASM  pour STRINGER.PAS"
	P8086
	PNO87
	MODEL TPASCAL

	DATASEG

	CODESEG


LABEL   UpAL NEAR
	; equivalent de UpCase sous pascal et C
	; AL modifie si necessaire
	cmp  al, 97             ; al<'a' ?
	jb   UpFin              ; oui!
	cmp  al, 122            ; al>'z' ?
	ja   UpFin              ; oui!
	xor  al, 32             ; -32!
UpFin:
	retn


PROC	UpCaseStr FAR Pointeur : DWORD      ; UpCaseStr(pointeur)
	PUBLIC UpCaseStr
	push ds

	cld
	lds  si, [Pointeur]     ; pointeur sur texte
	lodsb                  	; prend la longueur texte
	mov  cl, al             ; lg->cl
	xor  ch,ch
	jcxz @@Fin              ; rien a faire cx=0
	mov  ax, ds
	mov  es, ax
	mov  di, si             ; es:di = ds:si
@@Boucle:
	lodsb
	call UpAL
	stosb
	loop @@Boucle
@@Fin:
	pop  ds
	ret
ENDP	UpCaseStr

PROC    CompStr FAR  txt1 : DWORD, txt2 : DWORD, Up : BYTE
	PUBLIC CompStr
	; CompStr(var txt1,txt2 : string; up : boolean )
	push ds

	mov  dh, [Up]           ; z    -> dh
	les  di, [txt2]         ; txt2 -> es:di
	lds  si, [txt1]         ; txt1 -> ds:si
	xor  bx, bx             ; 0 -> bx
	mov  cl, [ds:si]        ; lgtxt1
	mov  dl, [es:di]        ; lgtxt2
	cmp  cl, dl             ; lg1>=lg2 ?
	jae  @@La           	; oui!
	mov  dl, cl             ; lg min->dl
@@La:
	jmp  SHORT @@Comm
@@Boucle:
	inc  bl
	mov  ah, [ds:bx+si]     ; txt1[bx]
	mov  ch, [es:bx+di]     ; txt2[bx]
	cmp  dh, 0
	je   @@Ici          	; min<>maj
	mov  al, ah
	call UpAL
	mov  ah, al
	mov  al, ch
	call UpAL
	mov  ch, al
@@Ici:
	cmp  ah, ch             ; txt1 comp txt2
	jb   @@Inf          	; inferieur
	ja   @@Sup          	; superieur
				; egal!
@@Comm:
	cmp  bl, dl
	jb   @@Boucle       	; boucle
	; c'est la taille qui va determiner l'etat
	mov  al, [ds:si]        ; lg1
	cmp  al, [es:di]        ; cmp lg1,lg2
	jb   @@Inf
	ja   @@Sup
	xor  ax, ax             ; renvoi 0
	jmp  SHORT @@Fin
@@Inf:
	mov  ax, 65535          ; renvoi -1
	jmp  SHORT @@FIN
@@Sup:
	mov  ax, 1              ; renvoi 1
@@Fin:
	pop  ds
	ret
ENDP	CompStr

PROC    EgalMem FAR x1:DWORD,x2:DWORD,lg:WORD
	PUBLIC EgalMem
	; EgalMem( var x1,x2; lg : word ) : boolean
	push ds

	mov  cx, [lg]           ; lg   -> cx
	jcxz @@YES
	les  di, [x1]           ; x2 -> es:di
	lds  si, [x2]           ; x1 -> ds:si
	cld
	repe cmpsb
	jne  @@NO               ; pas egal
@@YES:
	mov  ax, 1              ; egal!
	jmp  SHORT @@Fin
@@NO:
	xor  ax, ax
@@Fin:
	pop     ds
	ret
ENDP	EgalMem


	END
